.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include DriveList.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg == WM_INITDIALOG


           invoke GetDlgItem,hWnd,IDC_LIST
	          mov hList,eax
           invoke InsertColumns 
             call BuildDriveList


	.elseif uMsg == WM_CLOSE 
		    invoke EndDialog,hWnd,0		             
  .endif
  xor eax, eax
  ret
DlgProc endp

BuildDriveList proc
LOCAL lvi	:LV_ITEM

    invoke GetLogicalDriveStrings,sizeof szDrives,addr szDrives
	   lea esi,szDrives
 @@:
	invoke RtlZeroMemory,addr lvi,sizeof lvi
	invoke RtlZeroMemory,addr sfi,sizeof sfi
	invoke lstrlen,esi
	  test eax,eax
	    jz @F
 
	invoke GetDriveType,esi
       mov ebx,[szDriveTable+4*eax]
  
	   mov lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIR_ICON
	   mov lvi.iItem,edi
	   
      
	;get the icon of the item
    invoke SHGetFileInfo, esi, NULL, addr sfi, sizeof sfi,\
						SHGFI_ICON or SHGFI_ICON+SHGFI_ICONLOCATION +SHGFI_USEFILEATTRIBUTES	
		
	;insert the icon into the image list
	invoke ImageList_AddIcon, hImageList, sfi.hIcon
    
	 mov lvi.pszText,esi
	;in eax the index of the image
	   mov lvi.iImage, eax

	invoke SendMessage, hList, LVM_INSERTITEM, NULL,addr lvi
	   inc lvi.iSubItem
	   mov lvi.pszText, ebx
	invoke SendMessage,hList,LVM_SETITEM ,0,addr lvi

	; you are responsible for freeing the handle when you no longer need it!
	invoke DestroyIcon, sfi.hIcon 

	invoke lstrlen,esi
	   add esi,eax
	   inc esi
	   inc edi
	  jmp @B
 @@:
ret
BuildDriveList endp

InsertColumns proc
LOCAL lvc:LV_COLUMN
       invoke ImageList_Create, 32, 32, ILC_COLOR32 ,NULL, 64
           mov hImageList, eax
	    invoke SendMessage, hList, LVM_SETIMAGELIST,LVSIL_SMALL, hImageList
		;insert column name	
		mov eax, LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM
		mov lvc.imask, eax
		mov lvc.fmt, LVCFMT_LEFT
		mov lvc.lx, 100
		mov lvc.pszText, offset szDrive 
		mov lvc.iSubItem, 0
		invoke SendMessage, hList, LVM_INSERTCOLUMN, 0, addr lvc
		 or lvc.imask,LVCF_FMT
	    mov lvc.fmt,LVCFMT_LEFT ;CENTER
	    mov lvc.pszText,offset szType
	    mov lvc.lx,280
	    invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvc
    ret
InsertColumns endp

end start
